/*
 * x68000.c - JNetHack (based on NetHack 3.1.3 or later) for X68000
 *            depend functions.
 * written     1993/06/25 by Hiramoto Kouji (hiramoto@Angel.nanako.or.jp)
 * last change 1995/02/14 by Hiramoto Kouji (hiramoto@Angel.nanako.or.jp)
 * refer - NetHack 3.0 patch for X68000 by Kaoru Maeda, 90/1/25
 */
#include "hack.h"
#include "termcap.h"
#include "wintty.h"
#include "x68000.h"

/* `ƁAÕtHgLbV[`gp܂B
   gpȂ̃R[h̓eXgĂ܂B:-)             */
#define FCACHE

#define rgb(r, g, b)	(((r) << 6) | ((g) << 11) | ((b) << 1) | 1)
#define D1(a)   ((a) == 255 ? 0 : (a))
#define D2(a,b) (D1(a) * 255 + D1(b))

#ifdef FCACHE
typedef struct _FntBuf {
  short xl, yl;
  unsigned char buffer[16];
} FntBuf;
static FntBuf fonts[2][0x100];
#endif /* FCACHE */

int x68k_color = 0;
int x68k_bright = 0;
int x68k_standout = 0;
int x68k_footstep = 0;  /* 1 ȂΑՂc */
int x68k_condrv = 1;    /* 0 Ȃ condrv ̂ "ESC 0" "ESC 1" o͂ */
int x68k_opmdrv = 0;    /* 1 Ȃ opmdrv 𗘗pĉo͂ */
int bigscreen = 1;	/* ʃ[h: 1 = 96x32, 2 = 80x25 */

static unsigned short org_palette[16];
/* Original color from NetHack 3.0p10 for X68000 by Kaoru Maeda (Mad Player)*/
static unsigned short palette[16] = {
  rgb( 0,  0,  0),		/* NO_COLOR */
  rgb( 0, 29, 29),		/* CYAN */
  rgb(31, 29,  0),		/* YELLOW */
  rgb(31, 31, 31),		/* WHITE */
  rgb(31,  4,  4),		/* RED */
  rgb( 0, 29,  0),		/* GREEN */
  rgb(29, 16, 12),		/* BROWN */
  rgb(20, 20, 31),		/* BLUE */
  rgb(31, 10, 27),		/* MAGENTA */
  rgb(23, 23, 23),		/* GRAY */
  rgb(17, 17, 17),		/* BLACK */
  rgb(31, 16,  0),		/* ORANGE_COLORED */
  rgb(18, 24, 24),		/* HI_METAL */
  rgb(29, 26, 12),		/* HI_CLOTH */
  rgb(29, 23, 23),		/* HI_ORGANIC */
  rgb(27, 27, 27),		/* HI_MINERAL */
};

static unsigned int CRTC[8] = {
	116, 5, 17, 97, 438, 4, 31, 431,
};


void
x68k_chdrive(str)
char *str;
{
  if (str[1] == ':') {
    CHGDRV(toupper(str[0]) - 'A');
  }
}

void
get_scr_size()
{
  if (bigscreen == 1) {
    C_FNKMOD(0);		/* Function Key Line Mode - Normal Display */
    C_WIDTH(0);		/* 96x32 Text, 1024x1024 Gr, High reso, Graphic off. */
    C_WINDOW(0, 31);	/* Scroll region - 31 lines */
    CO = 96;
    LI = 31;
  } else {
    int i;

    C_FNKMOD(2);
    CRTMOD(0x0110);
    B_CONSOL(0,0,80-1,25-1);
    B_WPOKE((void *)0xe80028,0x0415);
    for (i = 0; i < 8; ++i) {
      B_WPOKE((void *)(0xe80000 + i * 2), CRTC[i]);
    }
    B_WPOKE((void *)0xe82400,0x0004);
    CO = 80;
    LI = 25;
  }
}

static int
DOSgetch()
{
  int i;

  while (!(i = K_KEYINP()))
    ;
  if ((K_KEYBIT(0x0A) & (32 + 64 + 128)) ||	/* XF1, XF2, XF3 */
      (K_KEYBIT(0x0B) & (1 + 2)) ||		/* XF4, XF5 */    
      (K_KEYBIT(0x0E) & (4 + 8))) {		/* OPT1, OPT2 */
    i |= 0x80;
  }

  return i;
}

int
tgetch()
{
  int ch;

  ch = DOSgetch();
  return((ch == '\r') ? '\n' : ch);
}

void
x68k_init_color(unsigned char col[])
{
  int i, j, c[3];

  for (i = 0; i < 16; ++i) {
    for (j = 0; j < 3; ++j) {
      c[j] = *col++;
      if (c[j] == 99) {
	c[j] = 0;
      }
      palette[i] = rgb(c[0], c[1], c[2]);
    }
  }
}

void
x68k_init_crtc(unsigned char crtc[])
{
  int i, c, d;

  for (i = 0; i < 8; ++i) {
    c = *crtc++;
    d = *crtc++;
    CRTC[i] = D2(c, d);
  }
}

void
x68k_init_palette()
{
  int i;
	
  for(i = 0; i < 16; ++i) {
    org_palette[i] = TPALET2(i, -1);
    TPALET2(i, palette[i]);
  }
}

void
x68k_restore_palette()
{
  int i;
	
  for(i = 0; i < 16; ++i) {
    TPALET2(i, org_palette[i]);
  }
}

void
init_hilite()
{
  unsigned int c, d;

  for (c = 0; c < CLR_MAX; c++) {
    d = (c ^ 0xffffffff) & 0xf;
    hilites[c] = (char *) alloc(2);
    hilites[c][0] = d << 4;
    hilites[c][1] = '\0';
  }

/* J[ɂ͊֌WȂǁA܂B(^^;) */
#ifdef FCACHE
  fonts[0][0x20].xl = 8;
  fonts[0][0x20].yl = 16;
#endif /* FCACHE */
}

void
cl_end() /* CLear END of line */
{
  B_COLOR(1);
  B_WPOKE(TVRAM_MASK_REG, 0x1ff);
  B_ERA_ED();
  B_WPOKE(TVRAM_MASK_REG, 0x033);
  B_COLOR(3);
}

void
clear_screen()
{
  B_COLOR(1);
  B_WPOKE(TVRAM_MASK_REG, 0x1ff);
  B_CLR_AL();
  B_WPOKE(TVRAM_MASK_REG, 0x133);
  B_COLOR(3);
  home();
}

void
cl_eos() /* CLear End Of Screen */
{
  B_COLOR(1);
  B_WPOKE(TVRAM_MASK_REG, 0x1ff);
  B_CLR_ED();
  B_WPOKE(TVRAM_MASK_REG, 0x133);
  B_COLOR(3);
}

void
term_start_color(color)
int color;
{
  if (color & BRIGHT) {
    color -= BRIGHT;
    x68k_bright = 4;
  } else {
    x68k_bright = 0;
  }
  x68k_color = hilites[color][0];
}

void
term_end_color()
{
  x68k_color = CLR_WHITE;
  x68k_bright = 0;
}

void
x68k_putc(unsigned int in_ch)
{
  register int b = (x68k_bright ? 1 : 0);
  register int x = ttyDisplay->curx * 8, y = ttyDisplay->cury * 16;
#ifndef FCACHE
  static struct FNTBUF font = {8, 16, {0}}, brank = {8, 16, {0}};
#endif /* !FCACHE */
  char c[2];

#if 0 /* for DEBUG */
	{
		FILE *fp;
		fp = fopen("/tmp/jnh0000", "a");
		fprintf(fp, "%d\n", in_ch);
		fclose(fp);
	}
#endif /* 1 for debug */

  B_COLOR(1 | x68k_bright);
  TCOLOR(1);
#ifdef FCACHE
  if (fonts[b][in_ch].xl == 0) { /* tHgLbVɂ邩? */
    B_PUTC(in_ch);
/*    c[0] = in_ch;
    c[1] = '\0';
    xputs(c);*/
    fonts[b][in_ch].xl = 8;
    fonts[b][in_ch].yl = 16;
    TEXTGET(x, y, (struct FNTBUF *) &fonts[b][in_ch]);
  } else {
    B_RIGHT(1);
/*    xputs("\x0c");*/
  }
  B_WPOKE(TVRAM_MASK_REG, 0x1f0); /* Ƃ肠Sv[ɏ */
  TEXTPUT(x, y, (struct FNTBUF *) &fonts[b][in_ch]);
  B_WPOKE(TVRAM_MASK_REG, 0x100 | x68k_color); /* spȃv[ */
  TEXTPUT(x, y, (struct FNTBUF *) &fonts[0][0x20]);
#else /* !FCACHE */
  B_PUTC(in_ch); /* Ƃɂ1\ăJ[\ʒui߂ȂƂȂ... */
  TEXTGET(x, y, (struct FNTBUF *) &font);
  B_WPOKE(TVRAM_MASK_REG, 0x1f0); /* Ƃ肠Sv[ɏ */
  TEXTPUT(x, y, (struct FNTBUF *) &font);
  B_WPOKE(TVRAM_MASK_REG, 0x100 | x68k_color); /* spȃv[ */
  TEXTPUT(x, y, (struct FNTBUF *) &brank);
#endif /* FCACHE */
  B_WPOKE(TVRAM_MASK_REG, 0x033);
  TCOLOR(3);
  B_COLOR(3 | x68k_standout);
}

void
x68k_speaker(struct obj *instr, char *melody)
{
  char *p, *q, d[1024];

  if (!x68k_opmdrv) {
    return;
  }

  m_init();
  m_alloc(1, 2000);
  m_assign(1, 1);

  switch (instr->otyp) {
  case WOODEN_FLUTE:	/* May charm snakes */
  case MAGIC_FLUTE: /* Make monster fall asleep */
    p = "@41 v15 o3"; /* IJi */
    q = "q8 t100 l4 ef.e8dc.d8c2."; /* qS */
    break;
  case TOOLED_HORN:	/* Awaken monsters or scare monsters */
  case FROST_HORN:	/* Idem wand of cold */
  case FIRE_HORN:	/* Idem wand of fire */
    p = "@35 v15 o4"; /* z ({͊pJȂ񂾂낤) */
    q = "q8 t120 l4 {cc-dd-}8e1";
    break;
  case BUGLE:	/* Awaken & attract soldiers */
    p = "@34 v15 o4"; /* gybg */
    q = "q5 t200 l8 <c.c8>g.g8<c.c8c.c8e.c8e.c8>g.g8q8<c2"; /* ˌbp */
    break;
  case WOODEN_HARP:	/* May calm Nymph */
  case MAGIC_HARP:	/* Charm monsters */
    p = "@13 v15 o5";/* n[v */
    q = "q8 t120 l4 e1f2&f.f8g2.de1"; /* AF}A */
    break;
  case LEATHER_DRUM:	/* Awaken monsters */
  case DRUM_OF_EARTHQUAKE:	/* create several pits */
    p = "@49 v15 o3"; /* eBpj */
    q = "q8 t120 l8 gcgcgcgcg1";
    break;
  default:
    /* G[bZ[W\? */
    return;
    break;
  }

  strcpy(d, p);
  if (melody[0] == '\0') {
    strcat(d, q);
  } else {
    strcat(d, "q7 t88 l4");
    strcat(d, melody);
  }
  m_trk(1, d);
  m_play(1, 0, 0, 0, 0, 0, 0, 0);
  while (m_stat(1))
    /* null loop */;
}
