/*
 * x68000.h - JNetHack (based on NetHack 3.1.3 or later) for X68000
 *            depend defines.
 * written     1993/06/25 by Hiramoto Kouji (hiramoto@Angel.nanako.or.jp)
 * last change 1995/02/14 by Hiramoto Kouji (hiramoto@Angel.nanako.or.jp)
 * refer - NetHack 3.0 patch for X68000 by Kaoru Maeda, 90/1/25
 */
#ifndef X68000_H
#define X68000_H

#ifdef CHDIR /* CHDIR of config.h & CHDIR of doslib.h ... */
# undef CHDIR
# define _CHDIR
#endif

#include <iocslib.h>
#include <doslib.h>
#include <ctype.h>
#include <conio.h>
#ifndef __LIBC__
# include <basic0.h>
#else
# include <unistd.h>
#endif
#include <music.h>

#ifdef _CHDIR
# undef CHDIR
# define CHDIR
# undef _CHDIR
#endif

/* eLXgʓANZX[hݒ - CRTC R21 */
#define	TVRAM_MASK_REG	((unsigned short *) 0xe8002a)

#define E extern

E int x68k_color;
E int x68k_bright;
E int x68k_standout;
E int x68k_footstep;
E int x68k_condrv;
E int x68k_opmdrv;

/* functions in x68000.c */
E void x68k_chdrive(char *);
E void x68k_init_palette();
E void x68k_restore_palette();
E void init_hilite();
E void cl_end();
E void clear_screen();
E void cl_eos();
E void term_start_color();
E void term_end_color();
E void x68k_init_color(unsigned char[]);
E void x68k_init_crtc(unsigned char[]);
E void x68k_putc(unsigned int);
E void x68k_speaker(struct obj *, char *);

#undef E

#endif /* X68000_H */
